Program threads; {program to demonstrate use of uthreads}

{***************************************************************************}
{*                                                                         *}
{* This is a little example of my uThreads unit for Turbo Pascal 7.0       *}
{* It demonstrates reentrant and preemptive threads, semaphores, signals,  *}
{* restarting and disposing of threads, and a pretty flame fractal.  ;)    *}
{*                                                                         *}
{***************************************************************************}

{$a+,b-,e-,g+,l-,o-,p-,q-,r-,s-,t-,v-,x+}
{$m 1024,65536,655360}

uses uthreads;  {my TP7.0 Threading Unit}

{***************************************************************************}
{*                                                                         *}
{*  These are some simple io hacks for demo purposes only.  may be buggy.  *}
{*                                                                         *}
{***************************************************************************}

Var color:Word;


Function Qrand:Word;Assembler; {*way* better than borland's random code}
const a:Word=$0123;b:Word=$4567;c:Word=$89ab;
asm Mov ax,a; Shl ax,1; Adc ax,2904; Xor ax,$aaaa; Mov a,ax; Adc ax,b
  Mov b,ax; Adc ax,c; Mov c,ax; end;
Function Readkey:Char;Assembler;
const ec:char=#0;
asm Mov al,EC; Mov EC,00h; cmp al,00h; Jnz @1; Xor ax,ax
	Int 16h; Cmp al,00h; Jnz @1; Mov EC,ah; @1: end;
Function Keypressed:Bytebool;Assembler;
asm Mov ax,0100h; int 16h; Mov al,False; jz @1; Inc al; @1: end;
Procedure WaitVBL;assembler;
asm Mov dx,03dah; @1:; In  al,dx; test al,08h; Jz @1; @2:;
  In  al,dx; test al,08h; Jnz  @2 end;
Procedure GraphMode;Assembler;
asm	mov ax,13h; int 10h end;
Procedure TextMode;Assembler;
asm	mov ax,03h; int 10h end;
Procedure OutTextXYB(Var s:String;x,y,c:Byte);Assembler;
asm Push bp; Mov ah,13h; Xor bh,bh; Mov bl,c; Mov al,01h; Mov dl,x; Mov dh,y;
  Les bp,s; Mov cl,es:[bp]; Xor ch,ch; Inc bp; Int 10h; Pop bp end;
procedure outtextxy(s:string;x,y,c:byte);begin outtextxyb(s,x,y,c);end;
Procedure setcolor(c:word);assembler;asm mov ax,c; mov color,ax end;
Procedure PutPixel(x,y:Word);assembler; {set a pixel}
asm mov ax,320; mul y; add ax,x; mov es,Sega000
  mov di,ax; mov al,color.byte; mov es:[di],al end;
Procedure hline(x,y,w:Word);assembler; {draw a horizontal line}
asm push x; push y; call putpixel; mov cx,w; rep stosb end;
procedure hput(var v;x,y,l:Word);assembler;
asm push x; push y; call putpixel; push ds; lds si,v;
  mov cx,l; rep movsb; pop ds; end;
Procedure bar(x1,y1,x2,y2:Word); {draw a filled box}
begin repeat hline(x1,y1,x2-x1); inc(y1); until y1>y2; end;
Procedure box(x,y,w,h,e,i:Word); {draw an outlined box}
begin setcolor(e);bar(x-1,y-1,x+w,y+h);setcolor(i);bar(x,y,x+w-1,y+h-1);end;

{***************************************************************************}
{*                                                                         *}
{*  This is the real demo code here.  Threads and main program only :)     *}
{*                                                                         *}
{***************************************************************************}

const
  size=81;
  title   ='uThreads Example Program 1.1';
  message1='Numbers [1234] restart a thread';
  message2='SHIFT + number kills that thread';
  message3='SPACE toggles throttling on/off';
  message4='ESC exits the demo';
  message5='Press any key to start!';
  throttle:boolean=true;

Var
  Flambe:Array[0..Size*size] of Byte;
  w1,w2,w3,w4,eh:pthreadport;
  exitsemaphore:longint;
  eventhandler_done:longint;
  keycode:char;
  icount:longint;
  message:String;

{***************************************************************************}
{*                                                                         *}
{* This demonstrates a simple dumb thread that takes no args and just runs *}
{*                                                                         *}
{***************************************************************************}

procedure bounce(var me:threadport);far;
var x,y,my,g,mx:integer;

  procedure drawball(x,y,c:integer);
  begin
    setcolor(c);
    bar(x+15,y+97,x+18,y+99);
  end;

begin
  box(15,20,140,80,1,0);         {draw top left subwindow}
  x:=0;y:=0;mx:=3;my:=-10;g:=1;

  repeat
    drawball(x,y,0);
    x:=x+mx;y:=y+my;my:=my+g;
    drawball(x,y,15);
    if (x>132) or (x<3)then mx:=-mx;
    if (y>-1) then my:=-10;
    pass;
  until (me.flags and tfkill)>0;
end;

{***************************************************************************}
{*                                                                         *}
{* This demonstrates a preemptive thread that waits on a semaphore         *}
{*                                                                         *}
{***************************************************************************}

Procedure flame(var me:threadport);far;
Var p,d:Word;
Begin
  box(165,110,140,80,1,0);       {draw bottom right subwindow}
  fillchar(flambe,sizeof(flambe),#0);
  repeat
    eventhandler_done:=0;        {clear the semaphore}
    wait(@EventHandler_Done);    {wait 'til eventhandler has run}
    for p:=0 to 79 do
    begin
      pass;
      hput(flambe[p*size],165,110+p,139);
    end;
    For p:=2 to Size*Pred(size) do
    Begin
      if (p and $ff)=$ff then{} pass; {pass every 256 iterations}
      d:=Flambe[p]shl 1+Flambe[p+Pred(size)]+Flambe[p+Succ(size)]+
      Flambe[p+Size]shl 2;
      if d>0 then flambe[p-2]:=Pred(d) shr 3;
    end;
    d:=QRand AND $7f or $20;
    For p:=Size*Pred(size) to Size*size do
    Begin
      If Qrand>$f000 then d:= QRand AND $7f or $20;
      FLambe[p]:=d;
    end;
  until (me.flags and tfkill)>0;
end;

const numstars=50;

{***************************************************************************}
{*                                                                         *}
{* This demonstrates a reentrant thread that takes simple arguements       *}
{*                                                                         *}
{***************************************************************************}

procedure stars(var me:threadport);far;
type
  reentrantjunk=record
    starx:array[1..numstars] of integer;
    stary:array[1..numstars] of integer;
  end;
var p:pointer;l,cx,cy:word;

  procedure drawstar(x,y,c:Integer);
  begin setcolor(c); putpixel(cx+x div 50,cy+y div 50);end;

  function randwhole(n:word):Integer;
  begin randwhole:=(1-random(2)*2)*(random(n-9)+10);end;


begin
  cx:=seg(me.port^);cy:=ofs(me.port^);
  box(cx-70,cy-40,140,80,1,0);        {draw our relative subwindow}
  getmem(p,sizeof(reentrantjunk));
  if p<>nil then with reentrantjunk(p^) do
  begin
    for l:=1 to numstars do
    begin
      starx[l]:=randwhole(30*50);stary[l]:=randwhole(20*50);
    end;
    repeat
      for l:=1 to numstars do
      begin
        drawstar(starx[l],stary[l],0);
        inc(starx[l],starx[l] div 10 );
        inc(stary[l],stary[l] div 10 );
        if (starx[l]> -70*50) and (starx[l]<69*50) and
          (stary[l]> -40*50)and (stary[l]<40*50)
        then drawstar(starx[l],stary[l],15)
        else
        begin
          starx[l]:=randwhole(30*50);stary[l]:=randwhole(20*50);
        end;
      end;
      pass;
    until (me.flags and tfkill)>0;
    freemem(p,sizeof(reentrantjunk));
  end;
end;

{***************************************************************************}
{*                                                                         *}
{* This demonstrates an Event Handler that semaphores and signals threads  *}
{*                                                                         *}
{***************************************************************************}

procedure EventHandler(var me:threadport);far;
begin
  repeat
    if keypressed then
    begin
      keycode:=readkey;
      if keycode=#0 then keycode:=char(128+ord(readkey)); {handle enhanced chars}
    end
    else keycode:=#0;
    case keycode of
      #27: exitsemaphore:=1;       {signal main program to exit}
      #32: throttle:=not throttle; {toggle the speed throttle on/off}

      '1': restartthread(w1^);     {restart the thread}
      '2': restartthread(w2^);
      '3': restartthread(w3^);
      '4': restartthread(w4^);

      '!': signalthread(w1^,tfkill,true);   {signal the thread to exit}
      '@': signalthread(w2^,tfkill,true);
      '#': signalthread(w3^,tfkill,true);
      '$': signalthread(w4^,tfkill,true);
    end;
    if throttle then waitvbl;{}
    eventhandler_done:=1;        {semaphore flame it's okay to continue}
    pass;
  until (me.flags and tfkill)>0
end;

{***************************************************************************}
{*                                                                         *}
{* This demonstrates creating and disposing of threads, and how to wait()  *}
{*                                                                         *}
{***************************************************************************}

begin
  icount:=0;

  graphmode;                     {initialize MCGA 320x200x256 mode}
  outtextxy(title,6,0,$e);       {draw our title}
  outtextxy(message1,4,9,$a);    {draw our title}
  outtextxy(message2,4,11,$b);   {draw our title}
  outtextxy(message3,4,13,$c);   {draw our title}
  outtextxy(message4,11,15,$d);  {draw our title}
  outtextxy(message5,8,23,$e);   {draw our title}

  readkey;
  box(1,11,318,188,1,9);         {draw main window}
  w1:=addthread(bounce);         {add thread for the bounce window}
  w2:=addthread(flame);          {add thread for the flame fractal window}
  setthreadpri(w2^,defaultpriority+1); {increase flame's priority}
  signalthread(w2^,tfpreempt,true);{make flame thread preemptive}
  defaultport:=ptr(235,60);      {set up parameters for reentrant stars()}
  w3:=addthread(stars);          {add thread for reentrant stars window}
  defaultport:=ptr(85,150);      {set up next instance of stars thread}
  w4:=addthread(stars);          {add another stars window}
  eh:=addthread(EventHandler);   {add thread to catch keypress events}
  exitsemaphore:=0;              {clear the main exit semaphore}
  wait(@exitsemaphore);          {run threads until semaphored to exit}

  {since we may have killed the thread, we have to test whether it exists
   before we dispose of it, otherwise we'll be trying to free() on a non-nil
   pointer in free heap which is really not a good thing to do. ;)}

  if removethread(w1^) then disposethread(w1^);
  if removethread(w2^) then disposethread(w2^);
  if removethread(w3^) then disposethread(w3^);
  if removethread(w4^) then disposethread(w4^);
  disposethread(eh^);            {the event handler need not be tested}
  textmode;                      {return in 80*25 textmode}
end.
